#!/usr/bin/env python
# das.py

"""
Author : peters 

Revision History:
File created on 29 Sep 2009.

"""
if __name__ == "__main__":
    import sys
    import os
    import logging
    import shutil

# Append current working dir to path

    sys.path.append(os.getcwd())

# Import methods and classes contained in this package

    from da.tools.initexit import CleanUpCycle
    from da.tools.initexit import ValidateOptsArgs
    from da.tools.initexit import ParseOptions
    from da.tools.initexit import StartLogger
    from da.tools.pipeline import *
    from da.tools.general import StoreData,RestoreData
    
# Start a logger for all that happens from here on

    try:
        pid = os.environ['JOB_ID']
    except:
        pid = os.getpid()
    
    dummy   = StartLogger(logfile='das.%s.log'%pid)

# Parse options from the command line

    opts, args = ParseOptions()

# Validate Options and arguments passed

    opts,args   = ValidateOptsArgs(opts,args)

# Create the Cycle Control object for this job    

    DaCycle      = JobStart(opts,args)

    msg          = header+"Initializing Da Cycle"+footer           ; logging.info(msg) 

    dummy        = DaCycle.Initialize()

    msg          = header+"starting JobInput"+footer           ; logging.info(msg) 

    StateVector  = JobInput(DaCycle)

    msg          = header+"starting SampleState"+footer             ; logging.info(msg) 

    dummy        = SampleState(DaCycle,StateVector)

    msg          = header+"starting Invert"+footer             ; logging.info(msg) 

    dummy        = Invert(DaCycle, StateVector)

    msg          = header+"starting Advance"+footer          ; logging.info(msg) 

    dummy        = Advance(DaCycle, StateVector)

    msg          = header+"starting SaveAndSubmit"+footer      ; logging.info(msg) 

    dummy        = SaveAndSubmit(DaCycle, StateVector)

    msg          = "Cycle finished...exiting"     ; logging.info(msg)

    dummy        = CleanUpCycle(DaCycle)

    sys.exit(0)

